from math import *
from general import *
import sys,getopt,pywt
from scipy.io.matlab import *
sys.path.append('readin')
sys.path.append('wavelet')
sys.path.append('struct')
sys.path.append('word')
sys.path.append('logistic_regression')
from plr import *
from get_seq import *
from wenergy import *
from DNAstruct import *
from wordcount import *
import numpy as np
import time

##################
#   class Seq    #
##################

class Seq:
  
    def __init__(self,posfile,seqlen,fd):
        self.posfile = posfile
        self.seqlen = seqlen
        self.seqfile = posfile.split('/')[-1]
        self.seq_dicode = []
        self.seq = []
        self.fasta_dir = fd
        
    getseq = get_seq # readin seq according to position file
    Nseq2wt_allmarker = Nseq2wt_allmarker # wavelet energy 
    Nseq2struct_allmarker = Nseq2struct_allmarker # DNA property 


##################
#  main function #
##################

def usage():
    print """
    command -p positive_file -n negative_file -l seqlen -g genome_directory -o output 
    """
def main():

    ####################################
    # get parameters from command line #
    ####################################
    try:
        #opts, args = getopt.getopt(sys.argv[1:], "p:n:t:l:o:s:", ["positive_file=","negative_file=","test_file=","seqlen=","output=","species="])
        opts, args = getopt.getopt(sys.argv[1:], "p:n:l:g:o:", ["positive_file=","negative_file=","seqlen=","genome_directory=","output="])
        
    except getopt.GetoptError:
        # print help information and exit:
        usage()
        sys.exit(2)
    if len(sys.argv)<11:
        usage()
        sys.exit()
    nucpos = None
    linkpos = None
    output =None
    species = ''
    seqlen = 0
    for o, a in opts:
        if o in ("-p","--positive_file"):
             nucpos = a
             if nucpos == None:
                 usage()
                 sys.exit()
        elif o in ("-o", "--output"):
             output = a
             if output == None:
                 usage()
                 sys.exit()
        elif o in ("-n","--negative_file"):
             linkpos = a
             if linkpos == None:
                 usage()
                 sys.exit()

        elif o in ('-l','--seqlen'):
             seqlen = int(a)
             
             if seqlen == 0:
                 usage()
             if np.all((2**np.arange(5,15)+1) != seqlen):
                 print "\nFalse: seqence length should be 2^n+1"
                 sys.exit()
        
        elif o in ('-g','--genome_directory'):
             genome_directory=a
             if genome_directory == None:
                 usage()
                 sys.exit()    

        else:
             assert False, "unhandled option"

    #fasta_dir = '..\\genome\\hg18\\' # its better using "\\" since '\' sometimes gives error message, for example, '\t' represent other meanings.  
    fasta_dir =genome_directory
    if 0:  # species info
      if species.upper() == 'MOUSE':
            fasta_dir = 'genome\mm8\\'
      elif species.upper() == 'HUMAN':
            fasta_dir = 'genome\hm\\'
      else: print "Please give the right species"
      print fasta_dir
    ########################
    #     get sequence     #
    ########################
    print "\nStepI: readin sequences"
    nuc = Seq(nucpos,seqlen,fasta_dir)
    nuc.getseq()
    link = Seq(linkpos,seqlen,fasta_dir)
    link.getseq()

    #####################
    #   wenergy         #
    #####################
    print "\nStepII: calculate wavelet energy"
    wenergy_train_nuc = nuc.Nseq2wt_allmarker(output)
    wenergy_train_link = link.Nseq2wt_allmarker(output)

    #####################
    #   DNA property    #
    #####################
    print "\nStepIII: calculate DNA-property"
    struct_train_nuc = nuc.Nseq2struct_allmarker(output)
    struct_train_link = link.Nseq2struct_allmarker(output)
    #####################
    #     word count    #
    #####################
    print "\nStep IV: word count"
    word_train,response, select_idx = seq2mtx_weng_allmarker_train(nuc.seq,link.seq,output)
    ####################
    #  save txt file   #
    ####################
    print "\nStep V: logistic regression"
    val_train = np.hstack((response, np.vstack((wenergy_train_nuc,wenergy_train_link)),word_train, np.vstack((struct_train_nuc,struct_train_link))))
    model = plr(val_train[:,1:],val_train[:,0].T)


    #savemat(output+'model', {'plr_model': model,'select_idx':select_idx },oned_as='row')
    np.savez(output+'model',model=model,select_idx=select_idx, seqlen=seqlen,name=output )
if __name__ == "__main__":
    t1=time.clock()
    main()
    print '\nTime elapsed:',time.clock()-t1



   



