import numpy as np
import sys
sys.path.append('../')
from general import overcount
from scipy.io.matlab import *
# calculate structural data as in Lee et al. 2007. ###################
def Nseq2struct_allmarker(self,output):
        property_list = np.load('struct/property_list.npy')
        property_list = property_list[3:]
        nseq = len(self.seq)
        seq = self.seq
        nproperty = len(property_list)
        nfield = 1 + 2 + nproperty #1 for GC; 2 for bending; nproperty for property_list; melting is not included as in Des' example
        struct_field = ['GC', 'Bend1', 'Bend2']
        struct_field.extend(property_list)
        
        struct = np.zeros([nseq, nfield])
        struct[:, 0] = DNA_GC(seq[0:nseq])
        struct[:, 1:3] = DNA_bend(seq[0:nseq])
        struct[:, 3:] = DNA_property(seq[0:nseq], property_list)
        field = struct_field
        #savemat(output+'struct', {'struct': field},oned_as='row')  
        #np.savez('struct/struct_'+ self.seqfile, field = field,val = struct)
        return struct
# GC content #######################################################
def DNA_GC(seq):
      nseq = len(seq)
      y = np.zeros(nseq)
      for j in range(nseq):
               s = seq[j]
               y[j] = (s.count('G')+s.count('C'))/float(len(s))
      return y

# DNA bend ########################################################
def DNA_bend(seq):
      nseq = len(seq)
      y = np.zeros([nseq, 2])
      for j in range(nseq):
             s = seq[j]
             dinuc1 = np.load('struct/bend1.npy')
             ndinuc1 = len(dinuc1)
             dinuc2 = np.load('struct/bend2.npy')
             ndinuc2 = len(dinuc2)
             for i in range(ndinuc1):
                    y[j, 0] = y[j, 0] + overcount(s,dinuc1[i,0])*float(dinuc1[i,1])
             for i in range(ndinuc2):
                    y[j, 1] = y[j, 1] + overcount(s,dinuc2[i,0])*float(dinuc2[i,1])

      y = y*(10**(-9))
      y = y * 3.46532972*(10**(-8))
      return y
# DNA property #######################################
  #Input: seq --- a list of sequences (cell array)
  #     property_list --- a list of properties
  #Output: y  --- an average structure property score for each sequence
def DNA_property(seq, property_list):
       nseq = len(seq);
       nprop = len(property_list)
       y = np.zeros([nseq, nprop])
       for i in range(nprop):
             para_file = 'struct\\' + property_list[i] +'.txt'
             dinucs = np.loadtxt(para_file, dtype = 'S')
                
             ndinucs = len(dinucs)
             for j in range(nseq):
                  s = seq[j]
                  for k in range(ndinucs):
                          y[j, i] = y[j, i] + overcount(s,dinucs[k,0].upper())*float(dinucs[k,1])
                  y[j, i] = y[j, i]/len(seq[j])
       return y
