# Nseq2wt_allmarker ######################
import pywt
import numpy as np
from math import floor
from scipy.io.matlab import *


int2nt=dict({1:'a',2:'c',3:'g',4:'t'})
def int22nt(d):
    return int2nt[int(str(d)[0])]+int2nt[int(str(d)[1])]



def Nseq2wt_allmarker(self,output):
        seqlen = float(self.seqlen)
        
        dicode            = [11, 12, 13, 14, 21, 22, 23, 24, 31, 32, 33, 34, 41, 42, 43, 44]
        dicode_complement = [44, 34, 24, 14, 43, 33, 23, 13, 42, 32, 22, 12, 41, 31, 21, 11]
        lwt = 0
        #random sequence
        nlev = int(floor(np.log2(seqlen)))
        s = pywt.wavedec(np.random.normal(0,1,seqlen), 'haar', level=nlev)
        #for i in range(len(s)):
         #  lwt += len(s[i])
        lwt = len(s)
        #sequence
        nseq = len(self.seq_dicode)
        pattern = np.zeros([nseq,lwt,16])
        pattern_flat = np.zeros([nseq,lwt*16])
        for ns in range (nseq):
            for i in range (16):
                C = []
                dicode_freq_forward = (self.seq_dicode[ns] == dicode[i]) + 0 #average over 3bp
                dicode_freq_reverse = (self.seq_dicode[ns][-1::-1] == dicode_complement[i]) + 0 #also count reverse seqeunce
                dicode_freq = 0.5*(dicode_freq_forward + dicode_freq_reverse);

                dwt_tmp = pywt.wavedec(dicode_freq, 'haar', level=nlev);
                energy_tmp = np.zeros(lwt) # Check
                for m in range(len(dwt_tmp)):
                    for n in range(len(dwt_tmp[m])):
                        C.append(dwt_tmp[m][n])
                        energy_tmp[m] += dwt_tmp[m][n]**2
                if np.linalg.norm(C)>0:        
                        energy = energy_tmp
                else:
                        energy = np.zeros(nlev + 1)
                
                pattern[ns, :, i] = energy
            pattern_flat[ns,:] = pattern[ns,...].flatten('F')

        wt_name=list()
        for d in dicode:
                for m in range(len(dwt_tmp)):
                        name=int22nt(d)+'_lev_'+str(m)
                        wt_name.append(name)
        #savemat(output+'wt_name', {'wt_name': wt_name},oned_as='row')                          
        #np.save('wavelet/pattern'+self.seqfile,pattern_flat)
        return pattern_flat

      
