import numpy as np
import sys
sys.path.append('../')
from general import overcount
from scipy.io.matlab import *

# evaluate word counts ###############            
def seq2mtx_weng_allmarker_train(nucseq,linkseq,output):
        allseq = nucseq[:]
        allseq.extend(linkseq)
        nnuc = len(nucseq)
        nlink = len(linkseq)
        nseq = nnuc + nlink
        word = np.load('word/word_list.npy')
        nword = len(word)
        ratio = np.zeros(nword,dtype=np.float32)
        seqfreq = np.zeros([nword,nseq], dtype=np.float32)

        for n in range(nword):
                
                s = word[n]
                slen = len(s)
                sc = seq_complement(s)
                if s == sc:
                    ncopy = 2.0  #for self-complementary sequence, the same word is counted twice
                else:
                    ncopy = 1.0
                
                nucfreq = np.zeros(nnuc,dtype=np.float32)
                for i in range(nnuc):
                    seq = nucseq[i].upper()
                    ks = len(seq) - slen + 1  #total number of words of length slen in query sequence
                    nucfreq[i] = (overcount(seq,s)+overcount(seq,sc)) /(ncopy*ks)
                
                linkfreq = np.zeros(nlink,dtype=np.float32);
                for i in range(nlink):
                    seq = linkseq[i].upper()
                    ks = len(seq) - slen + 1  #total number of words of length slen in query sequence
                    linkfreq[i] = (overcount(seq,s)+overcount(seq,sc))/(ncopy*ks)
                tol = 10**(-5)
                if np.var(np.hstack((nucfreq,linkfreq))) < tol:
                    ratio[n] = 0.
                else:
                    #[h, pval(j)] = ttest2(nucfreq, linkfreq)   # add func later
                
                    difference = np.mean(nucfreq) - np.mean(linkfreq)
                    s2x = np.var(nucfreq)
                    s2y = np.var(linkfreq)
                    s2xbar = s2x/nnuc
                    s2ybar = s2y/nlink
                    se = np.sqrt(s2xbar + s2ybar)
                    ratio[n] = difference/se
                    seqfreq[n] = np.hstack((nucfreq,linkfreq))
        sratio = np.argsort(abs(ratio))
        nselect = 200;   #rank words by their pvalue and select the top 200 ones
        select_idx = sratio[(-1)*nselect:]
        select_idx = select_idx[::-1]
        #select_word = np.take(word, select_idx)
        #select_ratio = np.take(abs(ratio),select_idx)
        train_val = np.take(seqfreq,select_idx,0)
        label = np.vstack((np.ones([nnuc, 1]), np.zeros([nlink, 1])))
        #np.savez(output+'word',seqfreq = seqfreq.T, select_word = select_word,select_ratio = select_ratio,train_val = train_val.T,label = label )
        return train_val.T,label,select_idx

def seq2mtx_weng_allmarker_test(testseq,select_idx,nselect=200):
        ntest = len(testseq)
        word = np.load('word/word_list.npy')
        select_word = np.take(word, select_idx)
        test_val = np.zeros([ntest, nselect],dtype=np.float32)
        for j in range(nselect):
                s = select_word[j]        
                slen = len(s)
                sc = seq_complement(s)
                if s == sc:
                    ncopy = 2.  #for self-complementary sequence, the same word is counted twice
                else:
                    ncopy = 1.
                
                for i in range(ntest):
                    seq = testseq[i].upper()
                    ks = len(seq) - slen + 1 #total number of words of length slen in query sequence
                    test_val[i,j] = (overcount(seq,s)+overcount(seq,sc))/(ncopy*ks)
        return test_val

# seq_complement
def seq_complement(s):
       #s = s.tostring()
       #s = s.replace('\x00','')
       sc = ''
       sc_tmp = s[-1::-1]
       for i in range(len(s)):
             if (sc_tmp[i] == 'A'):
                   sc = sc + 'T'
             elif (sc_tmp[i] == 'T'):
                   sc = sc + 'A'
             elif (sc_tmp[i] == 'G'):
                   sc = sc + 'C'
             elif (sc_tmp[i] == 'C'):
                   sc = sc + 'G'
             else:
                   sc = sc + sc_tmp[i]
                   
  
       return sc
